Public Member Functions | Protected Types | Protected Member Functions | Static Protected Member Functions | Protected Attributes | Static Protected Attributes | Friends

# SmallMapWindow Class Reference

Class managing the smallmap window. More...

`#include <smallmap_gui.h>`

Inheritance diagram for SmallMapWindow:

## Public Member Functions
| SmallMapWindow (const WindowDesc *desc, int window_number)
void | SmallMapCenterOnCurrentPos ()
Point | GetStationMiddle (const Station *st) const
| Get the center of the given station as point on the screen in the smallmap window.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | OnInit ()
| Notification that the nested widget tree gets initialized.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
virtual bool | OnRightClick (Point pt, int widget)
| A click with the right mouse button has been made on the window.
virtual void | OnMouseWheel (int wheel)
| The mouse wheel has been turned.
virtual void | OnTick ()
| Called once per (game) tick.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
virtual void | OnMouseOver (Point pt, int widget)
| The mouse is currently moving over the window or has just moved outside of the window.
## Protected Types
enum | SmallMapType { SMT_CONTOUR, SMT_VEHICLES, SMT_INDUSTRY, SMT_LINKSTATS, SMT_ROUTES, SMT_VEGETATION, SMT_OWNER }
| Types of legends in the WID_SM_LEGEND widget. More...
enum | ZoomLevelChange { ZLC_INITIALIZE, ZLC_ZOOM_OUT, ZLC_ZOOM_IN }
| Available kinds of zoomlevel changes. More...
## Protected Member Functions
Point | SmallmapRemapCoords (int x, int y) const
uint | GetMinLegendWidth () const
| Compute minimal required width of the legends.
uint | GetNumberColumnsLegend (uint width) const
| Return number of columns that can be displayed in width pixels.
uint | GetLegendHeight (uint num_columns) const
| Compute height given a number of columns.
uint | GetNumberRowsLegend (uint columns) const
| Get the number of rows in the legend from the number of columns.
void | SelectLegendItem (int click_pos, LegendAndColour *legend, int end_legend_item, int begin_legend_item=0)
| Select and toggle a legend item.
void | SwitchMapType (SmallMapType map_type)
| Select a new map type.
void | SetNewScroll (int sx, int sy, int sub)
| Set new scroll_x, scroll_y, and subscroll values after limiting them such that the center of the smallmap always contains a part of the map.
void | DrawMapIndicators () const
| Adds map indicators to the smallmap.
void | DrawSmallMapColumn (void *dst, uint xc, uint yc, int pitch, int reps, int start_pos, int end_pos, Blitter *blitter) const
| Draws one column of tiles of the small map in a certain mode onto the screen buffer, skipping the shifted rows in between.
void | DrawVehicles (const DrawPixelInfo *dpi, Blitter *blitter) const
| Adds vehicles to the smallmap.
void | DrawTowns (const DrawPixelInfo *dpi) const
| Adds town names to the smallmap.
void | DrawSmallMap (DrawPixelInfo *dpi) const
| Draws the small map.
Point | RemapTile (int tile_x, int tile_y) const
| Remap tile to location on this smallmap.
Point | PixelToTile (int px, int py, int *sub, bool add_sub=true) const
| Determine the tile relative to the base tile of the smallmap, and the pixel position at that tile for a point in the smallmap.
Point | ComputeScroll (int tx, int ty, int x, int y, int *sub)
| Compute base parameters of the smallmap such that tile (tx, ty) starts at pixel (x, y).
void | SetZoomLevel (ZoomLevelChange change, const Point *zoom_pt)
| Initialize or change the zoom level.
void | SetOverlayCargoMask ()
| Set the link graph overlay cargo mask from the legend.
void | SetupWidgetData ()
| Function to set up widgets depending on the information being shown on the smallmap.
uint32 | GetTileColours (const TileArea &ta) const
| Decide which colours to show to the user for a group of tiles.
int | GetPositionOnLegend (Point pt)
| Determines the mouse position on the legend.
## Static Protected Member Functions
static void | DrawVertMapIndicator (int x, int y, int y2)
| Draws vertical part of map indicator.
static void | DrawHorizMapIndicator (int x, int x2, int y)
| Draws horizontal part of map indicator.
## Protected Attributes
uint | min_number_of_columns
| Minimal number of columns in legends.
uint | min_number_of_fixed_rows
| Minimal number of rows in the legends for the fixed layouts only (all except SMT_INDUSTRY).
uint | column_width
| Width of a column in the WID_SM_LEGEND widget.
int32 | scroll_x
| Horizontal world coordinate of the base tile left of the top-left corner of the smallmap display.
int32 | scroll_y
| Vertical world coordinate of the base tile left of the top-left corner of the smallmap display.
int32 | subscroll
| Number of pixels (0..3) between the right end of the base tile and the pixel at the top-left corner of the smallmap display.
int | zoom
| Zoom level. Bigger number means more zoom-out (further away).
uint8 | refresh
| Refresh counter, zeroed every FORCE_REFRESH_PERIOD ticks.
LinkGraphOverlay * | overlay
## Static Protected Attributes
static SmallMapType | map_type = SMT_CONTOUR
| Currently displayed legends.
static bool | show_towns = true
| Display town names in the smallmap.
static const uint | LEGEND_BLOB_WIDTH = 8
| Width of the coloured blob in front of a line text in the WID_SM_LEGEND widget.
static const uint | INDUSTRY_MIN_NUMBER_OF_COLUMNS = 2
| Minimal number of columns in the WID_SM_LEGEND widget for the SMT_INDUSTRY legend.
static const uint | FORCE_REFRESH_PERIOD = 0x1F
| map is redrawn after that many ticks
static const uint | BLINK_PERIOD = 0x0F
| highlight blinking interval
## Friends
class | NWidgetSmallmapDisplay

## Detailed Description

Class managing the smallmap window.

Definition at line 43 of file smallmap_gui.h.

## Member Enumeration Documentation

enum SmallMapWindow::SmallMapType`[protected]`

Types of legends in the WID_SM_LEGEND widget.

Definition at line 46 of file smallmap_gui.h.

enum SmallMapWindow::ZoomLevelChange`[protected]`

Available kinds of zoomlevel changes.

Enumerator:

  ZLC_INITIALIZE | Initialize zoom level.
  ZLC_ZOOM_OUT | Zoom out.
  ZLC_ZOOM_IN | Zoom in.

Definition at line 57 of file smallmap_gui.h.

## Member Function Documentation

Point SmallMapWindow::ComputeScroll | ( | int | tx,
|  | int | ty,
|  | int | x,
|  | int | y,
|  | int * | sub |
| ) |  |  | `[protected]`

Compute base parameters of the smallmap such that tile (tx, ty) starts at pixel (x, y).

Parameters:

  | tx | Tile x coordinate.
  | ty | Tile y coordinate.
  | x | Non-negative horizontal position in the display where the tile starts.
  | y | Non-negative vertical position in the display where the tile starts.
  | sub | [out] Value of subscroll needed.

Returns:
  scroll_x, scroll_y values.

Definition at line 678 of file smallmap_gui.cpp.

References PixelToTile(), TILE_SIZE, and zoom.

static void SmallMapWindow::DrawHorizMapIndicator | ( | int | x,
|  | int | x2,
|  | int | y |
| ) |  |  | `[inline, static, protected]`

Draws horizontal part of map indicator.

Parameters:

  | x | X coord of left border of main viewport
  | x2 | X coord of right border of main viewport
  | y | Y coord of top/bottom border of main viewport

Definition at line 103 of file smallmap_gui.h.

References GfxFillRect(), and PC_VERY_LIGHT_YELLOW.

Referenced by DrawMapIndicators().

void SmallMapWindow::DrawSmallMap | ( | DrawPixelInfo * | dpi | ) | const`[protected]`

Draws the small map.

Basically, the small map is draw column of pixels by column of pixels. The pixels are drawn directly into the screen buffer. The final map is drawn in multiple passes. The passes are:

1. The colours of tiles in the different modes.
2. Town names (optional)

Parameters:

  | dpi | pointer to pixel to write onto

Definition at line 942 of file smallmap_gui.cpp.

References LinkGraphOverlay::Draw(), DrawMapIndicators(), DrawSmallMapColumn(), DrawTowns(), DrawVehicles(), BlitterFactoryBase::GetCurrentBlitter(), GfxFillRect(), map_type, min(), Blitter::MoveTo(), PC_BLACK, PixelToTile(), scroll_x, show_towns, TILE_SIZE, and zoom.

Referenced by DrawWidget().

void SmallMapWindow::DrawSmallMapColumn | ( | void * | dst,
|  | uint | xc,
|  | uint | yc,
|  | int | pitch,
|  | int | reps,
|  | int | start_pos,
|  | int | end_pos,
|  | Blitter * | blitter |
| ) |  |  | const`[protected]`

Draws one column of tiles of the small map in a certain mode onto the screen buffer, skipping the shifted rows in between.

Parameters:

  | dst | Pointer to a part of the screen buffer to write to.
  | xc | The X coordinate of the first tile in the column.
  | yc | The Y coordinate of the first tile in the column
  | pitch | Number of pixels to advance in the screen buffer each time a pixel is written.
  | reps | Number of lines to draw
  | start_pos | Position of first pixel to draw.
  | end_pos | Position of last pixel to draw (exclusive).
  | blitter | current blitter

Note:
  If pixel position is below `0`, skip drawing.

Definition at line 808 of file smallmap_gui.cpp.

References _settings_game, TileArea::ClampToMap(), GameSettings::construction, ConstructionSettings::freeform_edges, GetTileColours(), MapMaxX(), MapMaxY(), max(), Blitter::MoveTo(), Blitter::SetPixel(), TileXY(), and zoom.

Referenced by DrawSmallMap().

void SmallMapWindow::DrawTowns | ( | const DrawPixelInfo * | dpi | ) | const`[protected]`

Adds town names to the smallmap.

Parameters:

  | dpi | the part of the smallmap to be drawn into

Definition at line 887 of file smallmap_gui.cpp.

References Town::cache, DrawString(), FONT_HEIGHT_SMALL, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, Window::left, RemapTile(), SetDParam(), TownCache::sign, subscroll, TileX(), TileY(), Window::top, ViewportSign::width_small, and Town::xy.

Referenced by DrawSmallMap().

void SmallMapWindow::DrawVehicles | ( | const DrawPixelInfo * | dpi,
|  | Blitter * | blitter |
| ) |  |  | const`[protected]`

Adds vehicles to the smallmap.

Parameters:

  | dpi | the part of the smallmap to be drawn into
  | blitter | current blitter

Definition at line 848 of file smallmap_gui.cpp.

References FOR_ALL_VEHICLES, IsInsideMM(), map_type, PC_WHITE, RemapTile(), Blitter::SetPixel(), subscroll, TILE_SIZE, BaseVehicle::type, VEH_EFFECT, Vehicle::vehstatus, VS_HIDDEN, VS_UNCLICKABLE, Vehicle::x_pos, and Vehicle::y_pos.

Referenced by DrawSmallMap().

static void SmallMapWindow::DrawVertMapIndicator | ( | int | x,
|  | int | y,
|  | int | y2 |
| ) |  |  | `[inline, static, protected]`

Draws vertical part of map indicator.

Parameters:

  | x | X coord of left/right border of main viewport
  | y | Y coord of top border of main viewport
  | y2 | Y coord of bottom border of main viewport

Definition at line 91 of file smallmap_gui.h.

References GfxFillRect(), and PC_VERY_LIGHT_YELLOW.

Referenced by DrawMapIndicators().

void SmallMapWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 1142 of file smallmap_gui.cpp.

References _current_text_dir, _smallmap_industry_highlight, _smallmap_industry_highlight_state, column_width, DrawSmallMap(), DrawString(), LegendAndColour::end, FillDrawPixelInfo(), Industry::GetIndustryTypeCount(), GetNumberColumnsLegend(), GetNumberRowsLegend(), GfxFillRect(), INVALID_COMPANY, LEGEND_BLOB_WIDTH, map_type, PC_BLACK, PC_WHITE, SetDParam(), TILE_HEIGHT_STEP, WD_FRAMERECT_RIGHT, WID_SM_LEGEND, and WID_SM_MAP.

uint SmallMapWindow::GetLegendHeight | ( | uint | num_columns | ) | const`[inline, protected]`

Compute height given a number of columns.

Parameters:

  | num_columns | Number of columns.

Returns:
  Needed height for displaying the smallmap legends in pixels.

Definition at line 132 of file smallmap_gui.h.

References GetNumberRowsLegend(), WD_FRAMERECT_BOTTOM, and WD_FRAMERECT_TOP.

Referenced by NWidgetSmallmapDisplay::SetupSmallestSize().

uint SmallMapWindow::GetMinLegendWidth | ( |  | ) | const`[inline, protected]`

Compute minimal required width of the legends.

Returns:
  Minimally needed width for displaying the smallmap legends in pixels.

Definition at line 113 of file smallmap_gui.h.

References column_width, min_number_of_columns, and WD_FRAMERECT_LEFT.

Referenced by NWidgetSmallmapDisplay::SetupSmallestSize().

uint SmallMapWindow::GetNumberColumnsLegend | ( | uint | width | ) | const`[inline, protected]`

Return number of columns that can be displayed in width pixels.

Returns:
  Number of columns to display.

Definition at line 122 of file smallmap_gui.h.

References column_width.

Referenced by DrawWidget(), and GetPositionOnLegend().

uint SmallMapWindow::GetNumberRowsLegend | ( | uint | columns | ) | const`[inline, protected]`

Get the number of rows in the legend from the number of columns.

Those are at least min_number_of_fixed_rows and possibly more if there are so many cargoes, industry types or companies that they won't fit in the available space.

Parameters:

  | columns | Number of columns in the legend.

Returns:
  Number of rows needed for everything to fit in.

Definition at line 1259 of file smallmap_gui.cpp.

References _smallmap_cargo_count, _smallmap_company_count, _smallmap_industry_count, CeilDiv(), max(), and min_number_of_fixed_rows.

Referenced by DrawWidget(), GetLegendHeight(), and GetPositionOnLegend().

int SmallMapWindow::GetPositionOnLegend | ( | Point | pt | ) | `[protected]`

Determines the mouse position on the legend.

Parameters:

  | pt | Mouse position.

Returns:
  Legend item under the mouse.

Definition at line 1319 of file smallmap_gui.cpp.

References _current_text_dir, column_width, NWidgetBase::current_x, FONT_HEIGHT_SMALL, GetNumberColumnsLegend(), GetNumberRowsLegend(), NWidgetBase::pos_x, and NWidgetBase::pos_y.

Referenced by OnClick(), and OnMouseOver().

Point SmallMapWindow::GetStationMiddle | ( | const Station * | st | ) | const

Get the center of the given station as point on the screen in the smallmap window.

Parameters:

  | st | Station to find in the smallmap.

Returns:
  Point with coordinates of the station.

Definition at line 1604 of file smallmap_gui.cpp.

References BaseStation::rect, RemapTile(), and subscroll.

uint32 SmallMapWindow::GetTileColours | ( | const TileArea & | ta | ) | const`[inline, protected]`

Decide which colours to show to the user for a group of tiles.

Parameters:

  | ta | Tile area to investigate.

Returns:
  Colours to display.

Definition at line 754 of file smallmap_gui.cpp.

References GetSmallMapContoursPixels(), GetSmallMapIndustriesPixels(), GetSmallMapLinkStatsPixels(), GetSmallMapOwnerPixels(), GetSmallMapRoutesPixels(), GetSmallMapVegetationPixels(), GetSmallMapVehiclesPixels(), INVALID_TILE, map_type, and TILE_AREA_LOOP.

Referenced by DrawSmallMapColumn().

void SmallMapWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 1352 of file smallmap_gui.cpp.

References _left_button_clicked, _settings_client, _smallmap_cargo_count, _smallmap_company_count, _smallmap_industry_count, _smallmap_show_heightmap, SoundSettings::click_beep, NWidgetBase::current_x, NWidgetBase::current_y, LegendAndColour::end, FindWindowById(), GetPositionOnLegend(), Window::HandleButtonClick(), INVALID_VEHICLE, InvalidateWindowClassesData(), LegendAndColour::legend, map_type, NUM_INDUSTRYTYPES, NUM_NO_COMPANY_ENTRIES, PixelToTile(), NWidgetBase::pos_x, NWidgetBase::pos_y, RemapCoords(), scroll_x, SelectLegendItem(), Window::SetDirty(), SetOverlayCargoMask(), Window::SetWidgetLoweredState(), SetZoomLevel(), LegendAndColour::show_on_map, show_towns, ClientSettings::sound, SwitchMapType(), TILE_SIZE, WC_INDUSTRY_CARGOES, WC_MAIN_WINDOW, WID_SM_CENTERMAP, WID_SM_CONTOUR, WID_SM_DISABLE_ALL, WID_SM_ENABLE_ALL, WID_SM_INDUSTRIES, WID_SM_LEGEND, WID_SM_LINKSTATS, WID_SM_MAP, WID_SM_OWNERS, WID_SM_ROUTES, WID_SM_SHOW_HEIGHT, WID_SM_TOGGLETOWNNAME, WID_SM_VEGETATION, WID_SM_VEHICLES, WID_SM_ZOOM_IN, WID_SM_ZOOM_OUT, ZLC_ZOOM_IN, and ZLC_ZOOM_OUT.

void SmallMapWindow::OnInit | ( |  | ) | `[virtual]`

Notification that the nested widget tree gets initialized.

The event can be used to perform general computations.

Note:
  nested_root and/or nested_array (normally accessed via GetWidget()) may not exist during this call.

Reimplemented from Window.

Definition at line 1076 of file smallmap_gui.cpp.

References _linkstat_colours_in_legenda, BuildOwnerLegend(), column_width, LegendAndColour::end, GetStringBoundingBox(), Window::height, INDUSTRY_MIN_NUMBER_OF_COLUMNS, INVALID_COMPANY, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID(), LEGEND_BLOB_WIDTH, lengthof, max(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::MAX_SIZE, min_number_of_columns, min_number_of_fixed_rows, SetDParam(), WD_FRAMERECT_LEFT, and Window::width.

void SmallMapWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true` |
| ) |  |  | `[virtual]`

Some data on this window has become invalid.

Parameters:

  | data | Information about the changed data. data = 0: Displayed industries at the industry chain window have changed. data = 1: Companies have changed.
  | gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 1481 of file smallmap_gui.cpp.

References _displayed_industries, _smallmap_industry_count, HasBit(), map_type, Window::ReInit(), Window::SetDirty(), LegendAndColour::show_on_map, and SwitchMapType().

void SmallMapWindow::OnMouseOver | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[virtual]`

The mouse is currently moving over the window or has just moved outside of the window.

In the latter case pt is (-1, -1).

Parameters:

  | pt | the point inside the window that the mouse hovers over.
  | widget | the widget the mouse hovers over.

Reimplemented from Window.

Definition at line 1335 of file smallmap_gui.cpp.

References _smallmap_industry_count, _smallmap_industry_highlight, _smallmap_industry_highlight_state, BLINK_PERIOD, FORCE_REFRESH_PERIOD, GetPositionOnLegend(), INVALID_INDUSTRYTYPE, map_type, refresh, Window::SetDirty(), LegendAndColour::type, and WID_SM_LEGEND.

void SmallMapWindow::OnMouseWheel | ( | int | wheel | ) | `[virtual]`

The mouse wheel has been turned.

Parameters:

  | wheel | the amount of movement of the mouse wheel.

Reimplemented from Window.

Definition at line 1513 of file smallmap_gui.cpp.

References _settings_client, NWidgetBase::current_x, NWidgetBase::current_y, ClientSettings::gui, IsInsideMM(), Window::left, NWidgetBase::pos_x, NWidgetBase::pos_y, GUISettings::scrollwheel_scrolling, SetZoomLevel(), Window::top, ZLC_ZOOM_IN, and ZLC_ZOOM_OUT.

void SmallMapWindow::OnPaint | ( |  | ) | `[virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 1126 of file smallmap_gui.cpp.

References BuildOwnerLegend(), Window::DrawWidgets(), LegendAndColour::end, INVALID_COMPANY, Window::InvalidateData(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID(), and map_type.

bool SmallMapWindow::OnRightClick | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[virtual]`

A click with the right mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.

Returns:
  true if the click was actually handled, i.e. do not show a tooltip if tooltip-on-right-click is enabled.

Reimplemented from Window.

Definition at line 1505 of file smallmap_gui.cpp.

References _scrolling_viewport, and WID_SM_MAP.

void SmallMapWindow::OnScroll | ( | Point | delta | ) | `[virtual]`

Handle the request for (viewport) scrolling.

Parameters:

  | delta | the amount the viewport must be scrolled.

Reimplemented from Window.

Definition at line 1575 of file smallmap_gui.cpp.

References CursorVars::fix_at, PixelToTile(), scroll_x, Window::SetDirty(), SetNewScroll(), and TILE_SIZE.

Point SmallMapWindow::PixelToTile | ( | int | px,
|  | int | py,
|  | int * | sub,
|  | bool | add_sub = `true` |
| ) |  |  | const`[inline, protected]`

Determine the tile relative to the base tile of the smallmap, and the pixel position at that tile for a point in the smallmap.

Parameters:

  | px | Horizontal coordinate of the pixel.
  | py | Vertical coordinate of the pixel.
  | sub[out] | Pixel position at the tile (0..3).
  | add_sub | Add current subscroll to the position.

Returns:
  Tile being displayed at the given position relative to scroll_x and scroll_y.

Note:
  The subscroll offset is already accounted for.

Definition at line 646 of file smallmap_gui.cpp.

References subscroll, and zoom.

Referenced by ComputeScroll(), DrawSmallMap(), OnClick(), OnScroll(), and SetZoomLevel().

Point SmallMapWindow::RemapTile | ( | int | tile_x,
|  | int | tile_y |
| ) |  |  | const`[inline, protected]`

Remap tile to location on this smallmap.

Parameters:

  | tile_x | X coordinate of the tile.
  | tile_y | Y coordinate of the tile.

Returns:
  Position to draw on.

Definition at line 622 of file smallmap_gui.cpp.

References scroll_x, scroll_y, TILE_SIZE, and zoom.

Referenced by DrawMapIndicators(), DrawTowns(), DrawVehicles(), and GetStationMiddle().

void SmallMapWindow::SelectLegendItem | ( | int | click_pos,
|  | LegendAndColour * | legend,
|  | int | end_legend_item,
|  | int | begin_legend_item = `0` |
| ) |  |  | `[protected]`

Select and toggle a legend item.

When CTRL is pressed, disable all other items in the group defined by begin_legend_item and end_legend_item and keep the clicked one enabled even if it was already enabled before. If the other items in the group are all disabled already and CTRL is pressed enable them instead.

Parameters:

  | click_pos | the index of the item being selected
  | legend | the legend from which we select
  | end_legend_item | index one past the last item in the group to be inverted
  | begin_legend_item | index of the first item in the group to be inverted

Definition at line 1278 of file smallmap_gui.cpp.

References _ctrl_pressed, and LegendAndColour::show_on_map.

Referenced by OnClick().

void SmallMapWindow::SetNewScroll | ( | int | sx,
|  | int | sy,
|  | int | sub |
| ) |  |  | `[protected]`

Set new scroll_x, scroll_y, and subscroll values after limiting them such that the center of the smallmap always contains a part of the map.

Parameters:

  | sx | Proposed new scroll_x
  | sy | Proposed new scroll_y
  | sub | Proposed new subscroll

Definition at line 1545 of file smallmap_gui.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, InverseRemapCoords(), map_type, MapMaxX(), MapMaxY(), LinkGraphOverlay::RebuildCache(), scroll_x, scroll_y, subscroll, TILE_SIZE, and zoom.

Referenced by OnScroll(), and SetZoomLevel().

void SmallMapWindow::SetStringParameters | ( | int | widget | ) | const`[virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 1067 of file smallmap_gui.cpp.

References map_type, SetDParam(), and WID_SM_CAPTION.

void SmallMapWindow::SetZoomLevel | ( | ZoomLevelChange | change,
|  | const Point * | zoom_pt |
| ) |  |  | `[protected]`

Initialize or change the zoom level.

Parameters:

  | change | Way to change the zoom level.
  | zoom_pt | Position to keep fixed while zooming.

Precondition:
  `*zoom_pt` should contain a point in the smallmap display when zooming in or out.

Definition at line 706 of file smallmap_gui.cpp.

References Clamp(), lengthof, map_type, PixelToTile(), LinkGraphOverlay::RebuildCache(), scroll_x, Window::SetDirty(), SetNewScroll(), Window::SetWidgetDisabledState(), TILE_SIZE, WID_SM_ZOOM_IN, WID_SM_ZOOM_OUT, ZLC_INITIALIZE, ZLC_ZOOM_IN, ZLC_ZOOM_OUT, and zoom.

Referenced by OnClick(), and OnMouseWheel().

void SmallMapWindow::SwitchMapType | ( | SmallMapType | map_type | ) | `[protected]`

Select a new map type.

Parameters:

  | map_type | New map type.

Definition at line 1239 of file smallmap_gui.cpp.

References Window::LowerWidget(), Window::RaiseWidget(), LinkGraphOverlay::RebuildCache(), Window::SetDirty(), SetupWidgetData(), and WID_SM_CONTOUR.

Referenced by OnClick(), and OnInvalidateData().

The documentation for this class was generated from the following files:

- src/smallmap_gui.h
- src/smallmap_gui.cpp